﻿/*
130716
指定文字列を含むレイヤー以外を非表示にし
指定文字での新規レイヤーカンプを作成するスクリプト
*/

app.activeDocument.suspendHistory('差分レイヤーカンプ作成', 'jsx_fnc()');
function jsx_fnc(){
	try {
			main_fnc()
		} catch(e){
			//
		}
}

function main_fnc(){
	//----------------------------------------------------
	//ダイアログ設定
	//----------------------------------------------------
	setDialog = function(inputText){
	    var win = new Window("dialog", "カンプに指定したいレイヤー（グループ）名を入力");
	        var myText = win.add("edittext", [0, 0, 400, 300], "", {multiline: true});
	        myText.text = inputText;
	        myText.active = true;

	        win.add ("button", undefined, "OK");
	        win.add ("button", undefined, "Cancel");

	        if (win.show () == 1){
	            myName = myText.text;
	            makeComp();
	        }
	        else{
	            return;
	        }

	}
	setDialog("");

	//ダイアログに入力したものでカンプ設定
	function makeComp()
	{
	    var new_Name = [];
	    new_Name = myName.split("\n");
	    var n = new_Name.length;
	    for (var i=0; i<n; i++)
	    {
	        var set_new_Name = new_Name[i];
	        sabun(set_new_Name);
	    }
	}

	//------------------------------
	//ユーザー定義関数
	//------------------------------
	function sabun(arg_moji){
		layObj = activeDocument.layers;	//レイヤー　レイヤーセットの場合　layerSets
		l_num = layObj.length;	//レイヤーの個数
		
		for(i=0;i<l_num;i++)
		{
			layName = layObj[i].name;	//レイヤー数分それぞれのレイヤー名
			//それぞれのレイヤー名が各指定文字列を含んでいれば
			if(layName.indexOf(arg_moji)!=-1){	
				//表示する
				layObj[i].visible = true;	
			}
			//レイヤー名が各指定文字列を含まなければ
			else{
				//非表示にする
				layObj[i].visible = false;
			}
		}
		
		//現在の状態でカンプ作成（ログコピペ）
		var SetCamp = arg_moji;
		
		var idMk = charIDToTypeID( "Mk  " );
		var desc25 = new ActionDescriptor();
		var idnull = charIDToTypeID( "null" );
		var ref13 = new ActionReference();
		var idcompsClass = stringIDToTypeID( "compsClass" );
		ref13.putClass( idcompsClass );
		desc25.putReference( idnull, ref13 );
		var idUsng = charIDToTypeID( "Usng" );
		var desc26 = new ActionDescriptor();
		var iduseVisibility = stringIDToTypeID( "useVisibility" );
		desc26.putBoolean( iduseVisibility, true );
		var idusePosition = stringIDToTypeID( "usePosition" );
		desc26.putBoolean( idusePosition, false );
		var iduseAppearance = stringIDToTypeID( "useAppearance" );
		desc26.putBoolean( iduseAppearance, false );
		var idTtl = charIDToTypeID( "Ttl " );
		desc26.putString( idTtl, SetCamp );
		var idcompsClass = stringIDToTypeID( "compsClass" );
		desc25.putObject( idUsng, idcompsClass, desc26 );
		executeAction( idMk, desc25, DialogModes.NO );
	}
}